package ru.crystals.pos.api.card;

import ru.crystals.pos.spi.receipt.CardHolder;

/**
 * Сущность, описывающая владельца карты
 */
public class CardHolderEntity implements CardHolder {

    private String id;

    private String firstName;

    private String lastName;

    private String middleName;

    /**
     * Конструктор 
     */
    public CardHolderEntity() {
        super();
    }
    
    /**
     * Конструктор
     * @param id идентификатор клиента
     * @param firstName имя
     * @param lastName фамилия
     * @param middleName отчество
     */
    public CardHolderEntity(String id, String firstName, String lastName, String middleName) {
        super();
        this.id = id;
        this.firstName = firstName;
        this.lastName = lastName;
        this.middleName = middleName;
    }

    /* (non-Javadoc)
     * @see ru.crystals.pos.api.card.CardHolder#getId()
     */
    @Override
    public String getId() {
        return id;
    }

    /**
     * Установить идентификатор владельца карты
     * 
     * @param id идентификатор
     */
    public void setId(String id) {
        this.id = id;
    }

    /* (non-Javadoc)
     * @see ru.crystals.pos.api.card.CardHolder#getFirstName()
     */
    @Override
    public String getFirstName() {
        return firstName;
    }

    /**
     * Установить имя владельца карты
     * 
     * @param firstName имя
     */
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    /* (non-Javadoc)
     * @see ru.crystals.pos.api.card.CardHolder#getLastName()
     */
    @Override
    public String getLastName() {
        return lastName;
    }

    /**
     * Установить фамилию владельца карты
     * 
     * @param lastName
     *            фамилия
     */
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    /* (non-Javadoc)
     * @see ru.crystals.pos.api.card.CardHolder#getMiddleName()
     */
    @Override
    public String getMiddleName() {
        return middleName;
    }

    /**
     * Установить отчество владельца карты
     * 
     * @param middleName
     *            отчество
     */
    public void setMiddleName(String middleName) {
        this.middleName = middleName;
    }

    @Override
    public String toString() {
        return "CardHolderEntity{" +
                "id='" + id + '\'' +
                ", firstName='" + firstName + '\'' +
                ", lastName='" + lastName + '\'' +
                ", middleName='" + middleName + '\'' +
                '}';
    }
}
