package ru.crystals.pos.api.receipt;


import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import ru.crystals.pos.api.ext.loyal.dto.Slip;
import ru.crystals.pos.spi.receipt.LineItem;
import ru.crystals.pos.spi.receipt.Merchandise;

public class LineItemEntity implements LineItem, Serializable {
    private BigDecimal discountValue;
    private Merchandise merchandise;
    private int number;
    private boolean discountable;
    private BigDecimal originalPrice;
    private long quantity;
    private BigDecimal sum;
    private BigDecimal minPrice;
    private List<Slip> slips;
    private Map<String, String> data;
    private String pluginId;

    private boolean payBonusAllowed;
    private boolean accrueBonusAllowed;

    public LineItemEntity() {

    }

    @Override
    public BigDecimal getDiscountValue() {
        return discountValue;
    }

    @Override
    public Merchandise getMerchandise() {
        return merchandise;
    }

    @Override
    public int getNumber() {
        return number;
    }

    @Override
    public boolean isDiscountable() {
        return discountable;
    }

    @Override
    public BigDecimal getOriginalPrice() {
        return originalPrice;
    }

    @Override
    public long getQuantity() {
        return quantity;
    }

    @Override
    public BigDecimal getSum() {
        return sum;
    }

    @Override
    public BigDecimal getMinPrice() {
        return minPrice;
    }

    public void setDiscountValue(BigDecimal discountValue) {
        this.discountValue = discountValue;
    }

    public void setMerchandise(Merchandise merchandise) {
        this.merchandise = merchandise;
    }

    public void setNumber(int number) {
        this.number = number;
    }

    public void setDiscountable(boolean discountable) {
        this.discountable = discountable;
    }

    public void setOriginalPrice(BigDecimal originalPrice) {
        this.originalPrice = originalPrice;
    }

    public void setQuantity(long quantity) {
        this.quantity = quantity;
    }

    public void setSum(BigDecimal sum) {
        this.sum = sum;
    }

    public void setMinPrice(BigDecimal minPrice) {
        this.minPrice = minPrice;
    }

    @Override
    public List<Slip> getSlips() {
        if(slips == null) {
            slips = new ArrayList<>();
        }
        return slips;
    }

    @Override
    public Map<String, String> getData() {
        if(data == null) {
            data = new HashMap<>();
        }
        return data;
    }

    @Override
    public String getPluginId() {
        return pluginId;
    }

    public void setPluginId(String pluginId) {
        this.pluginId = pluginId;
    }

    @Override
    public boolean isPayBonusAllowed() {
        return payBonusAllowed;
    }

    @Override
    public boolean isAccrueBonusAllowed() {
        return accrueBonusAllowed;
    }

    public void setPayBonusAllowed(boolean payBonusAllowed) {
        this.payBonusAllowed = payBonusAllowed;
    }

    public void setAccrueBonusAllowed(boolean accrueBonusAllowed) {
        this.accrueBonusAllowed = accrueBonusAllowed;
    }

    @Override
    public String toString() {
        return "LineItemEntity{" +
                "discountValue=" + discountValue +
                ", merchandise=" + merchandise +
                ", number=" + number +
                ", discountable=" + discountable +
                ", originalPrice=" + originalPrice +
                ", quantity=" + quantity +
                ", sum=" + sum +
                ", minPrice=" + minPrice +
                ", slips=" + slips +
                ", data=" + data +
                ", pluginId='" + pluginId + '\'' +
                ", payBonusAllowed=" + payBonusAllowed +
                ", accrueBonusAllowed=" + accrueBonusAllowed +
                '}';
    }
}
