package ru.crystals.pos.spi;

/**
 * Интерфейс для чтения настроек.
 * 
 * <p>
 * Опции доступные для настройки указываются в <b>metainf.xml</b>
 */
public interface IntegrationProperties extends Injectable {

    /**
     * Получить общие настройки интеграции.
     * 
     * @return интерфейс для чтения настроек
     */
    PropertiesReader getServiceProperties();

    /**
     * Получить настройки плагина.
     * 
     * @return интерфейс для получения настроек
     */
    PropertiesReader getPluginProperties();

}
