package ru.crystals.pos.spi.equipment;

import ru.crystals.pos.api.ext.loyal.dto.Slip;
import ru.crystals.pos.spi.Injectable;

/**
 * Средство для печати {@link Slip сервисных документов}.
 */
public interface SetApiPrinter extends Injectable {

    /**
     * Распечатает указанный документ на принтере чеков.
     *
     * @param document документ, что надо распечатать
     * @throws SetApiPrinterException в случае возникновения ошибок при печати; {@link SetApiPrinterException#getMessage() текст}
     * содержит локализованное описание ошибки ("Открыта крышка ФР", "Закончилась чековая бумага", "Фатальная ошибка ККМ", и проч.)
     */
    void print(Slip document) throws SetApiPrinterException;
}