package ru.crystals.pos.spi.plugin.goods;


import ru.crystals.pos.spi.receipt.LineItem;
import ru.crystals.pos.spi.receipt.Receipt;

/**
 * Интерфейс запроса на удаление позиции из чека продажи
 */
public interface RemoveFromSaleRequest {

    /**
     * Позиция, которую необходимо удалить из чека
     * @return {@link LineItem}
     */
    LineItem getLineItem();

    /**
     * Чек, из которого удаляется позиция
     * @return {@link Receipt}
     */
    Receipt getReceipt();

    /**
     * Интерфейс для оповещения кассы о возможности удаления позиции из чека продажи
     * @return {@link RemoveFromSaleCallback}
     */
    RemoveFromSaleCallback getCallback();

}
