package ru.crystals.pos.spi.receipt;

import java.math.BigDecimal;

/**
 * Бонусный баланс карты
 *
 */
public interface BonusBalance {

    /**
     * Получить текущий баланс бонусов на счету
     *
     * @return баланс бонусов 
     */
    BigDecimal getBalance();

    /**
     * Получить количество бонусов, что позволено списать с этого баланса в текущем чеке
     *
     * @return {@code null}, если расчет этого "потолка списания" не производился (неизвестно сколько можно списать)
     */
    BigDecimal getSumAllowedToChargeOff();

    /**
     * Получить количество бонусов, что решили списать (или уже списали) с этого баланса в текущем чеке
     *
     * @return {@code null}, если количество бонусов для списания [еще] не ввели
     */
    BigDecimal getSumToChargeOff();

}
