package ru.crystals.pos.spi.receipt;

import java.math.BigDecimal;

/**
 * Сущность, описывающая товар (в чековой позиции).
 *
 * @author aperevozchikov
 */
public interface Merchandise {

    /**
     * Вернет Артикул (уникальный идентификатор) товара
     *
     * @return артикул товара
     */
    String getMarking();

    /**
     * Вернет Название товара
     *
     * @return Название товара
     */
    String getName();

    /**
     * Вернет Код производителя
     *
     * @return Код производителя
     */
    String getManufacturer();

    /**
     * Вернет Код страны-производителя
     *
     * @return Код страны-производителя
     */
    String getCountry();

    /**
     * Вернет цену товара
     *
     * @return цена товара
     */
    BigDecimal getPrice();

    /**
     * Вернет штрихкод товара
     * @return штрихкод
     */
    String getBarcode();

    /**
     * Вернет ставку НДС в процентах
     * @return значение НДС
     */
    float getNds();

}
